var flag_1 = false;
var flag_2 = false;

(function($) {
	$.fn.nanoLoad = function(settings) {
		settings = jQuery.extend({
			url: 'http://localhost:8080/',
			typeSearch: 'OW',
			arrDate: 0,
			depDate: 0
		}, settings);
		
		var our_form = $(this);
		var server_ac = settings.url + 'index.php';	
		this.iniForm = function(){

			if( !our_form.find('[name=utm_source]').length ){
				var host = location.host;
				our_form.find('#search-form').append('<input type="hidden" name="utm_source" value="'+host+'" />');
			}

			our_form.find('#search-form').attr('action', server_ac+'?go=search/index');
			our_form.find('#advanced_link').attr('href', settings.url);
			our_form.find('#advanced_link').click(function(e){
				e.preventDefault();
				location=$(this).attr('href');
			})
			if (settings.typeSearch){
				our_form.find('input[value='+settings.typeSearch+']').attr('checked', 'checked');
			}

			trip_type(our_form.find('input[name="trip_type"]:checked').val());
			our_form.find('input[name="trip_type"]').bind('click', function(){
				trip_type($(this).val());
			});
			function trip_type(value){
				if (value == 'RT'){
					our_form.find('#control_back_departure_date, #prefered_back_departure_type').fadeIn("slow");
					$.form_validator.config.group = 'RT';
				}
				else{
					our_form.find('#control_back_departure_date, #prefered_back_departure_type').fadeOut("slow");
					$.form_validator.config.group = 'OW';
				}
			}
			var str = '';
			
		$('#out_search')
			.val(settings.outSearch)
			.trigger('keydown').focus().hide()
			.ajaxComplete(function(){
				if (!flag_1){
					$('.ac_results:first li:first').mousedown();
					$('.ac_results:first').hide();
					$(this).show();
//					$(this).css('color','white');
					$(this).keydown(function(){
						if(!flag_1){
							$(this).css('color','');
							flag_1=true;
						}
					})
				}
			})
		
		$('#in_search')
			.val(settings.inSearch)
			.trigger('keydown').focus().hide()
			.ajaxComplete(function(){
				if (!flag_2){
					$('.ac_results:last li:first').mousedown();
					$('.ac_results:last').hide();
					$(this).show();					
//					$(this).css('color','white');
					$(this).keydown(function(){
						if(!flag_2){
							$(this).css('color','');
							flag_2=true;
						}
					})
				}
			});
			
			our_form.fadeIn();
		}
		
				
		this.iniValidator = function(){
			var config = {
					visitors: {
							'rt_prev_date': function (storage, field){
							
							//console.log($.form_validator.config.group );
							
							if ( $.form_validator.config.group == 'OW' ){
							
							}else{
								if($.form_validator.date_valid($('#back_departure_date')) && $.form_validator.date_valid($('#departure_date'))){
									var format = $.datepicker._defaults.dateFormat;
									var back = $.datepicker.parseDate( format, $('#back_departure_date').val(), {} );
									var dep = $.datepicker.parseDate( format, $('#departure_date').val(), {} );
									if(back != null){
										field = $('#back_departure_date');
											if((back - dep) < 0 )
								   			{
												storage.AddError(field, 'v-visitor' , 'Дата вылета меньше даты обратного вылета');
											} else {
												storage.RemoveError(field, 'v-visitor' , 'Дата вылета меньше даты обратного вылета');
											}
									}
								}
							}
							},

							'time_interval':function(storage, field){
								
								var needField = field.getAttribute('id');
								var len = 25; //magic...
								if(needField.charAt(10) == 'b'){
									len = 30
								}
								needField = needField.substring(0, len);
								
								var startInterval = $('#' + needField + 'from').val();
								var endInterval = $('#' + needField + 'to').val();
								
								if(parseInt(startInterval.substring(0, 2)) > parseInt(endInterval.substring(0, 2))){
									storage.AddError(needField + 'from', 'v-visitor' , 'invalid_flight_time_intervals');
								}
								else{
									storage.RemoveError(needField + 'from', 'v-visitor' , 'invalid_flight_time_intervals');
								}
								
								
							},

							'rt_daytime':function(storage, field){
								var departure = $('[name="prefered_departure_type"]').val();
								var arrival = $('[name="prefered_back_departure_type"]').val();
								var depDate = $('#departure_date').val();
								var arrDate = $('#back_departure_date').val();

								if(depDate == arrDate && depDate != null && depDate != ''){
									if(	(departure == 'afternoon' && arrival == 'morning') ||
										(departure == 'evening' && (arrival == 'morning' || arrival == 'afternoon'))){
										storage.AddError('prefered_departure_type', 'v-visitor' , 'invalid_flight_times');
									}
									else{
										storage.RemoveError('prefered_departure_type', 'v-visitor', 'invalid_flight_times');
									}
								}
							},

							'prev_iata': function (storage, field){
								//! FIXME check actual IATA
								//alert($(field).attr('name') );
								var value_out = $('[name="out_iata"]').val();
								var value_in = $('[name="in_iata"]').val();
								field = $('[name="in_iata"]');
								if (value_in && value_out == value_in){
									storage.AddError(field, 'v-visitor' , 'Аэропорт вылета совпадает с аэропортом прилета');
								}else{
									storage.RemoveError(field, 'v-visitor', 'Аэропорт вылета совпадает с аэропортом прилета');
								}

							},
							'people': function (storage, field) {
								//! scary validation :)
								var cnt = count_passengers();
								field = $('[name="adults"]');
								if (!cnt['all']){
									//console.log(cnt['all']);
									storage.AddError(field, 'no_passengers')
								} else {
									storage.RemoveError(field, 'no_passengers')
								}
								if (cnt['all'] > 6) {
									storage.AddError(field, 'Много пассажиров')
								} else {
									storage.RemoveError(field, 'Много пассажиров')
								}
								if( !cnt['adults'] && cnt['children'] && search_without_adults == "ban")
								{
									storage.AddError(field, 'search_without_adults_is_banned');
								}
								else
								{
									storage.RemoveError(field, 'search_without_adults_is_banned');
								}
								if(cnt['infants'] > cnt['adults']){
									storage.AddError(field, 'count_of_infants_must_be_same_with_adults');//$('select[name="infants"] option[value="' + cnt['adults'] + '"]').attr('selected', ' ');
								}
								else{
									storage.RemoveError(field, 'count_of_infants_must_be_same_with_adults');
								}
							}
					}
				}; 
			our_form.find('#search-form').bindFormValidator(config);
		}
		
		var me = this;
		this.load = function(){

			$.getScript(settings.url+'static/js/jquery.autocomplete.js', function(){
				$.getScript(settings.url+'static/js/nano/autocomplete.js', function(){
					rebind_complete('out_iata','out_search', 'ajax/autocomplete_json', 2, 10, false, settings.url);
					rebind_complete('in_iata','in_search', 'ajax/autocomplete_json', 2, 10, false, settings.url);
				});
			});

			//$('#out_search').val(settings.outSearch);


			//датапикеры
			$.getScript(settings.url+'static/js/jquery-ui-personalized-1.6rc4.js', function(){
				$.getScript(settings.url+'static/js/locale/ui.datepicker-ru.js');
				$.getScript(settings.url+'static/js/bind/datepicker.js', function(){
					
					$.datepicker.setDefaults({minDate: '+0d', maxDate: '+750d'});
					if (settings.arrDate >= 0){
						var arr_date = new Date();
						arr_date.setTime(arr_date.getTime()+settings.arrDate*24*60*60*1000);
						//arr_date.setDate(arr_date.getDate()+settings.arrDate);
						our_form.find('#departure_date').val(parseDate(arr_date));
						
						if (settings.depDate >= 0){
							var dep_date = new Date();
							dep_date.setTime(arr_date.getTime()+settings.depDate*24*60*60*1000)
							//dep_date.setDate(arr_date.getDate()+settings.depDate);
							our_form.find('#back_departure_date').val(parseDate(dep_date));
						}
					}
					$('input[name="back_departure_date"]').mousedown(
							function(e)
							{
								var minDate = $('input[name="departure_date"]').datepicker('getDate');
								if(minDate != null){
									$(e.target).datepicker('option','minDate', minDate);
								}
								var curDate = $(e.target).datepicker('getDate');
								if(curDate != null)
								if(minDate.getMonth() < curDate.getMonth())
								{
									$(e.target).datepicker('option', 'showCurrentAtPos', 1);
								}
								else
								{
									$(e.target).datepicker('option', 'showCurrentAtPos', 0);
								}
								$(e.target).datepicker('show');
							}
					);
					datepicker_ini("departure_date", {numberOfMonths: 2});
					datepicker_ini("back_departure_date", {numberOfMonths: 2});


					me.iniForm();
					
				});
			});	
			
			//валидация
			
			$.getScript(settings.url+'static/js/jquery.new_form_validator.js', function(){
				$.getScript(settings.url+'static/js/locale/ru.js', function(){
					$.getScript(settings.url+'static/js/jquery.livequery.js', function(){
						
						$.getScript(settings.url+'static/js/jquery.tooltip.js', function(){
							$.getScript(settings.url+'static/js/jquery.hint.js', function(){
								$.getScript(settings.url+'static/js/locale/components/FLIGHTS_ru.js');
								$.getScript(settings.url+'static/js/locale/components/MAIN_ru.js');
								$.getScript(settings.url+'static/js/locale/components/VALIDATION_ru.js');
							});
						});
						me.iniValidator();
					});
				});
			});
		}
		var form = this;
		form.load();
		/*$.getJSON(settings.url+'index.php?go=nano/test_domain&callback=?', function(data){
//			console.log(data);
			if (data.ok){
				form.load();
			}else{
				$('#search-form').html("Ошибка загрузки формы поиска");
				$('#nano_flght_form').css('display', 'block');
			}
		});*/



	};
})(jQuery);

function parseDate(date){
	var day = getFormatedVal(date.getDate());
	var month = getFormatedVal(date.getMonth()+1);
	var year = getFormatedVal(date.getFullYear());
	return day+'.'+month+'.'+year;
}

function getFormatedVal(val){
	if (val < 10) return '0'+val;return val;
}

function count_passengers(){
	var $adults = parseInt($('#search-form').find('select[name="adults"]').val());
	var $children =  parseInt($('#search-form').find('select[name="children"]').val());
	var $infants = 0;
	$infants += parseInt($('#search-form').find('select[name="infants"]').val());
	$children += $infants;
    $children += parseInt($('#search-form').find('select[name="infants_seat"]').val());
    return {'adults': $adults, 'children': $children, 'all': $adults+$children, 'infants': $infants};
}